diff --git a/lib/intel_batchbuffer.c b/lib/intel_batchbuffer.c
index 0da0043c0f50..6a585c7df967 100644
--- a/lib/intel_batchbuffer.c
+++ b/lib/intel_batchbuffer.c
@@ -298,9 +298,9 @@ intel_batchbuffer_data(struct intel_batchbuffer *batch,
  */
 void
 intel_blt_copy(struct intel_batchbuffer *batch,
-	      drm_intel_bo *src_bo, int src_x1, int src_y1, int src_pitch,
-	      drm_intel_bo *dst_bo, int dst_x1, int dst_y1, int dst_pitch,
-	      int width, int height, int bpp)
+	       drm_intel_bo *src_bo, int src_x1, int src_y1, int src_pitch,
+	       drm_intel_bo *dst_bo, int dst_x1, int dst_y1, int dst_pitch,
+	       int width, int height, int bpp)
 {
 	uint32_t src_tiling, dst_tiling, swizzle;
 	uint32_t cmd_bits = 0;
@@ -397,9 +397,9 @@ unsigned igt_buf_height(struct igt_buf *buf)
 	return buf->size/buf->stride;
 }
 
-render_copyfunc_t get_render_copyfunc(int devid)
+igt_render_copyfunc_t igt_get_render_copyfunc(int devid)
 {
-	render_copyfunc_t copy = NULL;
+	igt_render_copyfunc_t copy = NULL;
 
 	if (IS_GEN2(devid))
 		copy = gen2_render_copyfunc;
@@ -415,9 +415,9 @@ render_copyfunc_t get_render_copyfunc(int devid)
 	return copy;
 }
 
-media_fillfunc_t get_media_fillfunc(int devid)
+igt_media_fillfunc_t igt_get_media_fillfunc(int devid)
 {
-	media_fillfunc_t fill = NULL;
+	igt_media_fillfunc_t fill = NULL;
 
 	if (IS_GEN8(devid))
 		fill = gen8_media_fillfunc;
diff --git a/lib/intel_batchbuffer.h b/lib/intel_batchbuffer.h
index 333b08946789..3daf33cdf276 100644
--- a/lib/intel_batchbuffer.h
+++ b/lib/intel_batchbuffer.h
@@ -209,20 +209,20 @@ struct igt_buf {
 unsigned igt_buf_width(struct igt_buf *buf);
 unsigned igt_buf_height(struct igt_buf *buf);
 
-typedef void (*render_copyfunc_t)(struct intel_batchbuffer *batch,
-				  drm_intel_context *context,
-				  struct igt_buf *src, unsigned src_x, unsigned src_y,
-				  unsigned width, unsigned height,
-				  struct igt_buf *dst, unsigned dst_x, unsigned dst_y);
+typedef void (*igt_render_copyfunc_t)(struct intel_batchbuffer *batch,
+				      drm_intel_context *context,
+				      struct igt_buf *src, unsigned src_x, unsigned src_y,
+				      unsigned width, unsigned height,
+				      struct igt_buf *dst, unsigned dst_x, unsigned dst_y);
 
-render_copyfunc_t get_render_copyfunc(int devid);
+igt_render_copyfunc_t igt_get_render_copyfunc(int devid);
 
-typedef void (*media_fillfunc_t)(struct intel_batchbuffer *batch,
-				struct igt_buf *dst,
-				unsigned x, unsigned y,
-				unsigned width, unsigned height,
-				uint8_t color);
+typedef void (*igt_media_fillfunc_t)(struct intel_batchbuffer *batch,
+				     struct igt_buf *dst,
+				     unsigned x, unsigned y,
+				     unsigned width, unsigned height,
+				     uint8_t color);
 
-media_fillfunc_t get_media_fillfunc(int devid);
+igt_media_fillfunc_t igt_get_media_fillfunc(int devid);
 
 #endif
diff --git a/tests/gem_ctx_basic.c b/tests/gem_ctx_basic.c
index 67d6191e529c..3bfbe616eebd 100644
--- a/tests/gem_ctx_basic.c
+++ b/tests/gem_ctx_basic.c
@@ -74,7 +74,7 @@ static void init_buffer(drm_intel_bufmgr *bufmgr,
 static void *work(void *arg)
 {
 	struct intel_batchbuffer *batch;
-	render_copyfunc_t rendercopy = get_render_copyfunc(devid);
+	igt_render_copyfunc_t rendercopy = igt_get_render_copyfunc(devid);
 	drm_intel_context *context;
 	drm_intel_bufmgr *bufmgr;
 	int td_fd;
diff --git a/tests/gem_media_fill.c b/tests/gem_media_fill.c
index 7fc567612f97..ef73ed68a8fa 100644
--- a/tests/gem_media_fill.c
+++ b/tests/gem_media_fill.c
@@ -105,7 +105,7 @@ igt_simple_main
 	data_t data = {0, };
 	struct intel_batchbuffer *batch = NULL;
 	struct igt_buf dst;
-	media_fillfunc_t media_fill = NULL;
+	igt_media_fillfunc_t media_fill = NULL;
 	int i, j;
 
 	data.drm_fd = drm_open_any_render();
@@ -114,7 +114,7 @@ igt_simple_main
 	data.bufmgr = drm_intel_bufmgr_gem_init(data.drm_fd, 4096);
 	igt_assert(data.bufmgr);
 
-	media_fill = get_media_fillfunc(data.devid);
+	media_fill = igt_get_media_fillfunc(data.devid);
 
 	igt_require_f(media_fill,
 		"no media-fill function\n");
diff --git a/tests/gem_render_copy.c b/tests/gem_render_copy.c
index 7196a51a0198..2e029ebd2e54 100644
--- a/tests/gem_render_copy.c
+++ b/tests/gem_render_copy.c
@@ -125,7 +125,7 @@ int main(int argc, char **argv)
 	data_t data = {0, };
 	struct intel_batchbuffer *batch = NULL;
 	struct igt_buf src, dst;
-	render_copyfunc_t render_copy = NULL;
+	igt_render_copyfunc_t render_copy = NULL;
 	int opt;
 	int opt_dump_png = false;
 	int opt_dump_aub = drmtest_dump_aub();
@@ -149,7 +149,7 @@ int main(int argc, char **argv)
 		data.bufmgr = drm_intel_bufmgr_gem_init(data.drm_fd, 4096);
 		igt_assert(data.bufmgr);
 
-		render_copy = get_render_copyfunc(data.devid);
+		render_copy = igt_get_render_copyfunc(data.devid);
 		igt_require_f(render_copy,
 			      "no render-copy function\n");
 
diff --git a/tests/gem_render_linear_blits.c b/tests/gem_render_linear_blits.c
index 9d5d4ccf8cd0..b32a4cbb7574 100644
--- a/tests/gem_render_linear_blits.c
+++ b/tests/gem_render_linear_blits.c
@@ -61,7 +61,7 @@
 #define SIZE (HEIGHT*STRIDE)
 
 static uint32_t linear[WIDTH*HEIGHT];
-static render_copyfunc_t render_copy;
+static igt_render_copyfunc_t render_copy;
 
 static void
 check_bo(int fd, uint32_t handle, uint32_t val)
@@ -93,7 +93,7 @@ int main(int argc, char **argv)
 
 	fd = drm_open_any();
 
-	render_copy = get_render_copyfunc(intel_get_drm_devid(fd));
+	render_copy = igt_get_render_copyfunc(intel_get_drm_devid(fd));
 	if (render_copy == NULL) {
 		printf("no render-copy function, doing nothing\n");
 		return 77;
diff --git a/tests/gem_render_tiled_blits.c b/tests/gem_render_tiled_blits.c
index 0552af1fff80..2456c2fb9b05 100644
--- a/tests/gem_render_tiled_blits.c
+++ b/tests/gem_render_tiled_blits.c
@@ -57,7 +57,7 @@
 #define HEIGHT 512
 #define SIZE (HEIGHT*STRIDE)
 
-static render_copyfunc_t render_copy;
+static igt_render_copyfunc_t render_copy;
 
 static void
 check_bo(drm_intel_bo *bo, uint32_t val)
@@ -94,7 +94,7 @@ int main(int argc, char **argv)
 
 	fd = drm_open_any();
 
-	render_copy = get_render_copyfunc(intel_get_drm_devid(fd));
+	render_copy = igt_get_render_copyfunc(intel_get_drm_devid(fd));
 	if (render_copy == NULL) {
 		printf("no render-copy function, doing nothing\n");
 		return 77;
diff --git a/tests/gem_ring_sync_copy.c b/tests/gem_ring_sync_copy.c
index 1ab9b0ce1224..b8b1454c90e5 100644
--- a/tests/gem_ring_sync_copy.c
+++ b/tests/gem_ring_sync_copy.c
@@ -69,7 +69,7 @@ typedef struct {
 	uint32_t linear[WIDTH * HEIGHT];
 
 	struct {
-		render_copyfunc_t copy;
+		igt_render_copyfunc_t copy;
 		struct igt_buf *srcs;
 		struct igt_buf *dsts;
 	} render;
@@ -336,7 +336,7 @@ igt_main
 		igt_assert(data.bufmgr);
 		drm_intel_bufmgr_gem_enable_reuse(data.bufmgr);
 
-		data.render.copy = get_render_copyfunc(data.devid);
+		data.render.copy = igt_get_render_copyfunc(data.devid);
 		igt_require_f(data.render.copy,
 			      "no render-copy function\n");
 
diff --git a/tests/gem_ringfill.c b/tests/gem_ringfill.c
index 0dd222722fb2..3c3df73bb338 100644
--- a/tests/gem_ringfill.c
+++ b/tests/gem_ringfill.c
@@ -113,7 +113,7 @@ static void destroy_bo(struct bo *b)
 static int check_ring(drm_intel_bufmgr *bufmgr,
 		      struct intel_batchbuffer *batch,
 		      const char *ring,
-		      render_copyfunc_t copy)
+		      igt_render_copyfunc_t copy)
 {
 	struct igt_buf src, tmp, dst;
 	struct bo bo;
@@ -197,7 +197,7 @@ static void blt_copy(struct intel_batchbuffer *batch,
 
 drm_intel_bufmgr *bufmgr;
 struct intel_batchbuffer *batch;
-render_copyfunc_t copy;
+igt_render_copyfunc_t copy;
 int fd;
 
 igt_main
@@ -219,7 +219,7 @@ igt_main
 		/* Strictly only required on architectures with a separate BLT ring,
 		 * but lets stress everybody.
 		 */
-		copy = get_render_copyfunc(batch->devid);
+		copy = igt_get_render_copyfunc(batch->devid);
 		igt_require(copy);
 	}
 
diff --git a/tests/gem_seqno_wrap.c b/tests/gem_seqno_wrap.c
index 664e552cbfcc..25f11b4ea419 100644
--- a/tests/gem_seqno_wrap.c
+++ b/tests/gem_seqno_wrap.c
@@ -145,7 +145,7 @@ static void render_copyfunc(struct igt_buf *src,
 			    int height)
 {
 	const int src_x = 0, src_y = 0, dst_x = 0, dst_y = 0;
-	render_copyfunc_t rendercopy = get_render_copyfunc(devid);
+	igt_render_copyfunc_t rendercopy = igt_get_render_copyfunc(devid);
 	static int warned = 0;
 
 	if (rendercopy) {
diff --git a/tests/gem_stress.c b/tests/gem_stress.c
index 20f2ca335485..a994f7f9424f 100644
--- a/tests/gem_stress.c
+++ b/tests/gem_stress.c
@@ -338,7 +338,7 @@ static void render_copyfunc(struct igt_buf *src, unsigned src_x, unsigned src_y,
 			    unsigned logical_tile_no)
 {
 	static unsigned keep_gpu_busy_counter = 0;
-	render_copyfunc_t rendercopy = get_render_copyfunc(devid);
+	igt_render_copyfunc_t rendercopy = igt_get_render_copyfunc(devid);
 
 	/* check both edges of the fence usage */
 	if (keep_gpu_busy_counter & 1)
diff --git a/tests/kms_fbc_crc.c b/tests/kms_fbc_crc.c
index d05d14e0eca4..07a572d2d488 100644
--- a/tests/kms_fbc_crc.c
+++ b/tests/kms_fbc_crc.c
@@ -206,7 +206,7 @@ static void fill_render(data_t *data, uint32_t handle,
 	struct intel_batchbuffer *batch;
 	struct igt_buf src_buf, dst_buf;
 	const uint8_t buf[4] = { color, color, color, color };
-	render_copyfunc_t rendercopy = get_render_copyfunc(data->devid);
+	igt_render_copyfunc_t rendercopy = igt_get_render_copyfunc(data->devid);
 
 	igt_skip_on(!rendercopy);
 
diff --git a/tests/kms_flip.c b/tests/kms_flip.c
index e89ae99d2abf..70d67e572059 100644
--- a/tests/kms_flip.c
+++ b/tests/kms_flip.c
@@ -247,11 +247,11 @@ static void emit_fence_stress(struct test_output *o)
 static void emit_dummy_load__rcs(struct test_output *o)
 {
 	const struct kmstest_fb *fb_info = &o->fb_info[o->current_fb_id];
-	render_copyfunc_t copyfunc;
+	igt_render_copyfunc_t copyfunc;
 	struct igt_buf sb[2], *src, *dst;
 	int i, limit;
 
-	copyfunc = get_render_copyfunc(devid);
+	copyfunc = igt_get_render_copyfunc(devid);
 	if (copyfunc == NULL)
 		return emit_dummy_load__bcs(o);
 